from typing import Optional, List
from datetime import datetime

from runai import models
from runai.api.runai_api_service import RunaiAPIService, deprecated_message


class DeploymentsApi(RunaiAPIService):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        self._api_client = api_client

    @deprecated_message()
    def get_deployment(
        self,
        uuid: str,
        deployment_id: str,
    ):
        r"""
        ## Deprecated endpoint, consider alternative method

        ### Description
        Get a deployment by id

        ### Parameters:
        ```python
        uuid: str
        deployment_id: str
        ```
        uuid: Unique identifier of the cluster
        deployment_id: the unique Id of the deployment (UUID)

        ### Example:
        ```python
        DeploymentsApi(
            uuid='uuid_example',
                        deployment_id='deployment_id_example'
        )
        ```
        """

        resource_path = f"/v1/k8s/clusters/{uuid}/deployments/{deployment_id}".replace(
            "_", "-"
        )
        method = "GET"
        return self._api_client.call_api(
            resource_path=resource_path,
            method=method,
        )

    @deprecated_message()
    def get_deployments(
        self,
        uuid: str,
    ):
        r"""
        ## Deprecated endpoint, consider alternative method

        ### Description
        List deployments

        ### Parameters:
        ```python
        uuid: str
        ```
        uuid: Unique identifier of the cluster

        ### Example:
        ```python
        DeploymentsApi(
            uuid='uuid_example'
        )
        ```
        """

        resource_path = f"/v1/k8s/clusters/{uuid}/deployments".replace("_", "-")
        method = "GET"
        return self._api_client.call_api(
            resource_path=resource_path,
            method=method,
        )
